#include <cstdio>
#include <vector>

using namespace std;

struct edge {
  int to;
  int val;
};

int main()
{
  int n, m, a, k;

  scanf("%d%d%d%d", &n, &m, &a, &k);
  while (n != 0 && m != 0 && a != 0 && k != 0) {
    vector< vector<edge> > graph(n);
    vector<bool> vynechany(n, false);
    for (int i = 0; i < m; i++) {
      int t1, t2, d;
      edge e1, e2;
      scanf("%d%d%d", &t1, &t2, &d);
      e1.to = --t2; e1.val = d;
      e2.to = --t1; e2.val = d;
      graph[t1].push_back(e1);
      graph[t2].push_back(e2);
    }
	int alive = n;
    for (int i = 0; i < a; i++) {
      int B;
      scanf("%d", &B);

      int root = B;    
      vector<int> vzd(n, -1);
      vzd[B] = 0;
      while (vzd[root] <= k) {
	if(vynechany[root] == false) alive--;
	vynechany[root] = true;
        int min = 0;
	for (int j = 1; j < graph[root].size(); j++){
		if(((graph[root][j].val < graph[root][min].val) || vynechany[graph[root][min].to] == true) && vynechany[graph[root][j].to] == false) min = j;
		}
	vzd[graph[root][min].to] = vzd[root] + graph[root][min].val;
	root = graph[root][min].to;
      }
	printf("%d\n", alive);
    }
    
    scanf("%d%d%d%d", &n, &m, &a, &k);
  }
  return 0;
}
